using System;
using System.Windows.Forms;

namespace JamesKovacs.Samples.MinimizeToTray {
    public partial class Form1 : Form {
        private FormWindowState m_previousWindowState;

        public Form1() {
            InitializeComponent();
            // Store the initial window state that we want to restore to when we double-click the tray icon
            m_previousWindowState = (this.WindowState == FormWindowState.Minimized ? FormWindowState.Normal : this.WindowState);
        }

        protected override void OnResize(EventArgs e) {
            base.OnResize(e);
            // We need to keep track of whether you're minimizing from a normal or maximized window
            if(this.WindowState != FormWindowState.Minimized) {
                m_previousWindowState = this.WindowState;
            }
            notifyIcon1.Visible = (this.WindowState == FormWindowState.Minimized);
            this.Visible = !notifyIcon1.Visible;
        }

        private void notifyIcon1_MouseDoubleClick(object sender, MouseEventArgs e) {
            this.Visible = true;
            notifyIcon1.Visible = false;
            this.WindowState = m_previousWindowState;
        }
    }
}